"use strict";

var _defineProperty = function (obj, key, value) { return Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); };

exports.createEventWrapper = createEventWrapper;
Object.defineProperty(exports, "__esModule", {
  value: true
});
var STOP_IMMEDIATE_PROPAGATION_FLAG = Symbol("stop immediate propagation flag");
exports.STOP_IMMEDIATE_PROPAGATION_FLAG = STOP_IMMEDIATE_PROPAGATION_FLAG;
var CANCELED_FLAG = Symbol("canceled flag");
exports.CANCELED_FLAG = CANCELED_FLAG;
var DISPATCH_FLAG = Symbol("dispatch flag");

exports.DISPATCH_FLAG = DISPATCH_FLAG;
var wrapperPrototypeDefinition = {
  stopPropagation: {
    value: function stopPropagation() {},
    writable: true,
    configurable: true
  },
  stopImmediatePropagation: {
    value: function stopImmediatePropagation() {
      this[STOP_IMMEDIATE_PROPAGATION_FLAG] = true;
    },
    writable: true,
    configurable: true
  },
  preventDefault: {
    value: function preventDefault() {
      if (this.cancelable === true) {
        this[CANCELED_FLAG] = true;
      }
    },
    writable: true,
    configurable: true
  },
  defaultPrevented: {
    get: function get() {
      return this[CANCELED_FLAG];
    },
    enumerable: true,
    configurable: true
  }
};

function createEventWrapper(event, eventTarget) {
  var timeStamp = typeof event.timeStamp === "number" ? event.timeStamp : Date.now();

  return Object.create(Object.create(event, wrapperPrototypeDefinition), (function () {
    var _Object$create = {
      type: { value: event.type, enumerable: true },
      target: { value: eventTarget, enumerable: true },
      currentTarget: { value: eventTarget, enumerable: true },
      eventPhase: { value: 2, enumerable: true },
      bubbles: { value: Boolean(event.bubbles), enumerable: true },
      cancelable: { value: Boolean(event.cancelable), enumerable: true },
      timeStamp: { value: timeStamp, enumerable: true },
      isTrusted: { value: false, enumerable: true } };

    _defineProperty(_Object$create, STOP_IMMEDIATE_PROPAGATION_FLAG, { value: false, writable: true });

    _defineProperty(_Object$create, CANCELED_FLAG, { value: false, writable: true });

    _defineProperty(_Object$create, DISPATCH_FLAG, { value: true, writable: true });

    return _Object$create;
  })());
}